#include <Xm/BulletinB.h>
#include <Xm/PushB.h>

Widget Shell1 = NULL;
Arg args[20];
int n;
XtAppContext app_context;

static XtArgVal GetPixel(colorstr)
char *colorstr;
{
   XrmValue from, to;

   from.size = strlen(colorstr) +1;
   if (from.size < sizeof(String)) from.size = sizeof(String);
   from.addr = colorstr;
   to.addr = NULL;
   XtConvert(Shell1, XmRString, &from, XmRPixel, &to);

   return ((XtArgVal) *((XtArgVal *) to.addr));
}


void main (argc, argv)
int argc;
char **argv;
{
   Widget bboard, pbutton;  

/* Initialize the Xt Intrinsics */

   Shell1 = XtAppInitialize (&app_context, "Setcolors", NULL, 0, &argc, argv,
   NULL, args, 0);

/* Create a bulletin board widget */

   n = 0;
   XtSetArg(args[n], XmNbackground, GetPixel("#ffffff"));  n++;
   bboard = XmCreateBulletinBoard(Shell1, "bboard", args, n);

   XtManageChild(bboard);

/* Create a PushButton as a child of the bulletin board */

   n = 0;
   XtSetArg(args[n], XmNbackground, GetPixel("red"));  n++;
   pbutton = XmCreatePushButton(bboard, "button1", args, n);

   XtManageChild(pbutton);

   XtRealizeWidget(Shell1);

   XtAppMainLoop(app_context);
}
